//-------------------------------------------------------------------------------------------------
// <copyright file="IBurnController.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

DECLARE_INTERFACE_IID_(IBurnController, IUnknown, "e1e09b84-3fca-11dd-8291-001d09081dd9")
{
    STDMETHOD(Run)() PURE;

    STDMETHOD(Prepare)(
        __in DWORD dwPackageIndex,
        __in REQUEST_STATE requested
        ) PURE;

    STDMETHOD(Cache)(
        __in DWORD dwPackageIndex
        ) PURE;

    STDMETHOD(CacheElevatedPackage)(
        __in DWORD dwPackageIndex,
        __in ACTION_STATE execute,
        __in ACTION_STATE rollback
        ) PURE;

    STDMETHOD(Elevate)(
        __in_opt HWND hwndParent
        ) PURE;

    STDMETHOD(Execute)(
        __in REQUEST_STATE requested
        ) PURE;

    STDMETHOD(ExecuteElevatedPackage)(
        __in DWORD dwPackageIndex,
        __in BOOL fExecute
        ) PURE;

    STDMETHOD(LoadUXInterface)(
        __out IBurnUserExperience** ppUX
        ) PURE;
};


DECLARE_INTERFACE_IID_(IBurnControllerTestable, IUnknown, "f1e09b84-3fca-11dd-8291-001d09081dd9")
{
    STDMETHOD_(void, OnCachePackages)(
        __in DWORD dwPackageId
        ) PURE;
};


HRESULT BurnCreateController(
    __in IBurnModel* pModel,
    __in IBurnView* pView,
    __in IBurnExecuteEngine* pExeEngine,
    __in IBurnExecuteEngine* pMsiEngine,
    __in IBurnCacheEngine* pExtractEngine,
    __in IBurnCacheEngine* pDownloadEngine,
    __in IInstallationAbstractionLayer* pInstallationAbstractionLayer,
    __out IBurnController** ppController
    );
