//-------------------------------------------------------------------------------------------------
// <copyright file="IBurnProperties.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

DECLARE_INTERFACE_IID_(IBurnProperties, IUnknown, "e1e09b89-3fca-11dd-8291-001d09081dd9")
{
    STDMETHOD(GetNumericValueByName)(
        __in_z LPCWSTR wzProperty,
        __out LONGLONG* pllValue
        ) PURE;

    STDMETHOD(GetStringValueByName)(
        __in_z LPCWSTR wzProperty,
        __out_z LPWSTR* psczValue
        ) PURE;

    STDMETHOD(GetVersionValueByName)(
        __in_z LPCWSTR wzProperty,
        __out DWORD64* pqwValue
        ) PURE;

    STDMETHOD(GetFormattedValueByName)(
        __in_z LPCWSTR wzProperty,
        __out_z LPWSTR* psczValue
        ) PURE;

    STDMETHOD(SetNumeric)(
        __in_z LPCWSTR wzProperty,
        __in LONGLONG llValue
        ) PURE;

    STDMETHOD(SetString)(
        __in_z LPCWSTR wzProperty,
        __in_z_opt LPCWSTR wzValue
        ) PURE;

    STDMETHOD(SetVersion)(
        __in_z LPCWSTR wzProperty,
        __in DWORD64 qwValue
        ) PURE;

    STDMETHOD(FormatString)(
        __in_z LPCWSTR wzIn,
        __out_z LPWSTR* ppwzOut
        ) PURE;

    STDMETHOD(EscapeString)(
        __in_z LPCWSTR wzIn,
        __out_z LPWSTR* ppwzOut
        ) PURE;

    STDMETHOD(EvaluateCondition)(
        __in_z LPCWSTR wzExpr,
        __out BOOL* pf
        ) PURE;
};


HRESULT BurnCreateProperties(
    __out IBurnProperties** ppProperties
    );
