//-------------------------------------------------------------------------------------------------
// <copyright file="BurnControllerTestShim.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

namespace MS
{
namespace Tools
{
namespace WindowsInstallerXml
{
namespace Test
{
namespace Bootstrapper
{
    public ref class BurnControllerTestShim
    {
    public:
        void Prepare(int packageIndex, RequestState requested);

        void Cache(int packageIndex);

        void Elevate();

        void Execute(RequestState requested);

        void Run();

    public:
        void OnCachePackages(int packageIndex);

    public:
        BurnControllerTestShim(BurnModelTestShim^ model, IBurnViewShim^ viewShim);

        BurnControllerTestShim(BurnModelTestShim^ model, IBurnViewShim^ viewShim, IInstallationAbstractionLayerShim^ ialShim);

        BurnControllerTestShim(IBurnController* pController);

        ~BurnControllerTestShim();

    protected:
        !BurnControllerTestShim();

    private:
        void Construct(BurnModelTestShim^ model, IBurnViewShim^ viewShim, IInstallationAbstractionLayerShim^ ialShim);

        void Destroy();

    internal:
        IBurnController* m_pController;
    };
}
}
}
}
}
