//-------------------------------------------------------------------------------------------------
// <copyright file="BurnPackageTestShim.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

namespace MS
{
namespace Tools
{
namespace WindowsInstallerXml
{
namespace Test
{
namespace Bootstrapper
{
    public enum class LoggingLevel
    {
        Unknown,
        Normal,
        Verbose,
        Debug
    };

    public ref class BurnPackageTestShim
    {
    public:
        property Version^ InstalledVersion { Version^ get(); }

        property Version^ PackageVersion { Version^ get(); }

        property BurnPropertiesTestShim^ Properties { BurnPropertiesTestShim^ get(); }

        property bool IsPerMachine { bool get(); }

        property String^ LogPath { String^ get(); }

        property LoggingLevel LogLevel { LoggingLevel get(); }

        BurnPayloadTestShim^ GetPayload(int index);

        void AddPayload(BurnPayloadTestShim^ payload);

    internal:
        static BurnPackageTestShim^ Create(IBurnPackage* pPackage);

    protected:
        BurnPackageTestShim();

        virtual ~BurnPackageTestShim();

        !BurnPackageTestShim();

    internal:
        void Destroy();

    internal:
        IBurnPackage* m_pPackage;
    };
}
}
}
}
}
