//-------------------------------------------------------------------------------------------------
// <copyright file="BurnPayloadTestShim.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

namespace MS
{
namespace Tools
{
namespace WindowsInstallerXml
{
namespace Test
{
namespace Bootstrapper
{
    public enum class PayloadSourceType
    {
        None,
        Relative,
        Embedded,
        Download,
    };

    public ref class BurnPayloadTestShim
    {
    public:
        property String^ CompletedPath { String^ get(); }

        property String^ CompletedRoot { void set(String^); }

        property String^ SourcePath { String^ get(); }

        property PayloadSourceType SourceType { PayloadSourceType get(); }

        property String^ WorkingPath { String^ get(); }

    internal:
        BurnPayloadTestShim(IBurnPayload* pPayload);

    public:
        BurnPayloadTestShim(PayloadSourceType sourceType, Guid guid, String^ sourcePath, String^ localPath, UInt64 size, array<Byte>^ digest, bool temporary);

        virtual ~BurnPayloadTestShim();

    protected:
        !BurnPayloadTestShim();

    private:
        void Destroy();

    internal:
        IBurnPayload* m_pPayload;
    };
}
}
}
}
}
