//-------------------------------------------------------------------------------------------------
// <copyright file="BurnViewTestShim.h" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

#pragma once

namespace MS
{
namespace Tools
{
namespace WindowsInstallerXml
{
namespace Test
{
namespace Bootstrapper
{
    ref class BurnControllerTestShim; // forward declare.

    public ref class BurnViewTestShim : public IBurnViewShim
    {
    public: // IBurnViewShim
        virtual IBurnView* GetView()
        {
            m_pView->AddRef();
            return m_pView;
        }

    public: // IBurnView
        void Initialize(BurnModelTestShim^ model, BurnControllerTestShim^ controller);

        void Run();

        void Uninitialize();

    public: // IBurnCore
        void SetPackageProperty(String^ packageId, String^ name, String^ value);

        String^ GetControlText(int nControlIdx);

    public:
        BurnViewTestShim();

        BurnViewTestShim(BurnMode^ mode);

        ~BurnViewTestShim();

    protected:
        !BurnViewTestShim();

    private:
        void Destroy();

    internal:
        IBurnView* m_pView;
        BOOL m_fManuallyInitialized;
    };
}
}
}
}
}
