//-------------------------------------------------------------------------------------------------
// <copyright file="TestConstants.cs" company="Microsoft">
//    Copyright (c) Microsoft Corporation.  All rights reserved.
//    
//    The use and distribution terms for this software are covered by the
//    Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
//    which can be found in the file CPL.TXT at the root of this distribution.
//    By using this software in any fashion, you are agreeing to be bound by
//    the terms of this license.
//    
//    You must not remove this notice, or any other, from this software.
// </copyright>
//-------------------------------------------------------------------------------------------------

namespace MS.Tools.WindowsInstallerXml.Test.Bootstrapper
{
    using System;

    internal class TestConstants
    {
        public const int KB = 1024;
        public const int MB = 1048576;
        public const int GB = 1073741824;

        public const int Success = 0;
        public const int FalseSuccess = 1;

        public const int AlreadyAssigned = -2147024811; // 0x80070055
        public const int ErrorFileNotFound = -2147024894; // 0x80070002
        public const int ErrorNotFound = -2147023728; // 0x80070490
        public const int ErrorNotImplemented = -2147467263; // 0x80004001
        public const int ErrorOpenFailed = -2147024786; // 0x8007006e
        public const int InstallFailure = -2147023293; // 0x80070643
        public const int InvalidArgument = -2147024809; // 0x80070057
        public const int InvalidData = -2147024883; // 0x80070057
        public const int Unexpected = -2147418113; // 0x8000ffff
    }
}
